import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.io.File;

import static org.junit.Assert.*;
import java .util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class HamletParserTest {
    private String hamletText;
    private HamletParser hamletParser;


    @Before
    public void setUp() {
        this.hamletParser = new HamletParser();
        this.hamletText = hamletParser.getHamletData();

    }

    @Test
    public void testChangeHamletToLeon() {

        Pattern replace = Pattern.compile("Hamlet");
        Matcher matcher2 = replace.matcher(hamletText );
       String actual=   matcher2.replaceAll("Leon") ;
       //System.out.println(actual);
        String expected=hamletText.toString().replaceAll("Hamlet","Leon") ;
       Assert.assertEquals(expected,actual  )  ;


    }

    @Test
    public void testChangeHoratioToTariq() {

        Pattern replace = Pattern.compile("Horatio");
        Matcher matcher2 = replace.matcher(hamletText );
        String actual=   matcher2.replaceAll("Tariq") ;
        //System.out.println(actual);
        String expected=hamletText.toString().replaceAll("Horatio","Tariq") ;
        Assert.assertEquals(expected,actual  );
    }

    @Test
    public void testFindHoratio() {
        String regex = "Horatio";

        Pattern pattern = Pattern.compile(regex);

        Matcher matcher = pattern.matcher(hamletText );
        boolean expected=matcher.find() ;
        System.out.println(expected );
        Assert.assertTrue(expected ) ;


    }

    @Test
    public void testFindHamlet() {
       // String patternString1 = "((John) (.+?)) ";
        String regex = "((Hamlet) (.+?))";

        Pattern pattern = Pattern.compile(regex);

        Matcher matcher = pattern.matcher(hamletText );
        boolean expected=matcher.find() ;
        System.out.println(expected );
        Assert.assertTrue(expected ) ;

    }
}